#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityVipBagCFG.h"
std::auto_ptr<M_ActivityVipBagCFG> M_ActivityVipBagCFG::msSingleton(nullptr);

int M_ActivityVipBagCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityVipBagCFGData* M_ActivityVipBagCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityVipBagCFGData>& M_ActivityVipBagCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityVipBagCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityVipBagCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityVipBagCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mPurchaseCount = element->IntAttribute("PurchaseCount");
		{
			const char* bagId = element->Attribute("bagId");
			std::vector<std::string> vecbagId;
			boost::split(vecbagId, bagId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecbagId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecbagId[i].c_str(), &temp))
				{
					data.mbagId.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityVipBagCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityVipBagCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityVipBagCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityVipBagCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityVipBagCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readInt(L, "PurchaseCount", data.mPurchaseCount);
		LuaCfgHelper::readVectorInt(L, "bagId", data.mbagId);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityVipBagCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityVipBagCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityVipBagCFG* M_ActivityVipBagCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityVipBagCFG());
	}
	return msSingleton.get();
}

void M_ActivityVipBagCFG::Release()
{
	msSingleton.reset(nullptr);
}
